package com.enactor.training.paymentService.service.messages.gcash;

import java.util.Date;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.namespace.QName;

import com.enactor.core.application.process.ApplicationProcessDataType;
import com.enactor.core.application.process.IApplicationProcessDataType;
import com.enactor.core.entities.PropertyValidationException;
import com.enactor.core.utilities.Logger;	

/**
 * Add comments for the MessageHead entity implementation here
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "MessageHead", namespace=com.enactor.training.PackageInfo.NSURI_TRAINING, propOrder = {
	"function",
	"clientId",
	"clientSecret",
	"version",
	"reqMsgId",
	"reqTime",
	"respTime"
})

@XmlRootElement(name = MessageHead.ENTITY_NAME, namespace=com.enactor.training.PackageInfo.NSURI_TRAINING)
public class MessageHead implements IMessageHead {

	/** My logger instance */
	@SuppressWarnings("unused")
	private static final Logger logger = Logger.getLogger(MessageHead.class);
	
	/** serialVersionUID */
	private static final long serialVersionUID = 1L;
	
	/** Entity name. */
	public static final String ENTITY_NAME = "messageHead";
	
	/** Entity QName */
	public static final QName ENTITY_QNAME = new QName(com.enactor.training.PackageInfo.NSURI_TRAINING, ENTITY_NAME, com.enactor.training.PackageInfo.PREFIX_TRAINING);

	/** Entity application data type name */
	public static final String ENTITY_DATA_TYPE_NAME = "enactor.gcash.messages.MessageHead";
	
	/** Entity application data type */
	public static final IApplicationProcessDataType ENTITY_DATA_TYPE = new ApplicationProcessDataType(ENTITY_DATA_TYPE_NAME, IMessageHead.class.getName());	
		
	/** The Function field */
	private String function = null;
	
	/** The ClientId field */
	private String clientId = null;
	
	/** The ClientSecret field */
	private String clientSecret = null;
	
	/** The Version field */
	private String version = null;
	
	/** The ReqMsgId field */
	private String reqMsgId = null;
	
	/** The ReqTime field */
	private String reqTime = null;
	
	/** The RespTime field */
	private String respTime = null;

	/**************************************************************************
	 * MessageHead Interface
	 **************************************************************************/
	
	@Override
	public void setFunction(String function) throws PropertyValidationException {
		this.function = function;
	}
	
	@Override
	public String getFunction() {
		return (function == null) ? "" : function;
	}
	
	@Override
	public void setClientId(String clientId) throws PropertyValidationException {
		this.clientId = clientId;
	}
	
	@Override
	public String getClientId() {
		return (clientId == null) ? "" : clientId;
	}
	
	@Override
	public void setClientSecret(String clientSecret) throws PropertyValidationException {
		this.clientSecret = clientSecret;
	}
	
	@Override
	public String getClientSecret() {
		return (clientSecret == null) ? "" : clientSecret;
	}
	
	@Override
	public void setVersion(String version) throws PropertyValidationException {
		this.version = version;
	}
	
	@Override
	public String getVersion() {
		return (version == null) ? "" : version;
	}
	
	@Override
	public void setReqMsgId(String reqMsgId) throws PropertyValidationException {
		this.reqMsgId = reqMsgId;
	}
	
	@Override
	public String getReqMsgId() {
		return (reqMsgId == null) ? "" : reqMsgId;
	}
	
	@Override
	public void setReqTime(String reqTime) throws PropertyValidationException {
		this.reqTime = reqTime;
	}
	
	@Override
	public String getReqTime() {
		return reqTime;
	}
	
	@Override
	public void setRespTime(String respTime) throws PropertyValidationException {
		this.respTime = respTime;
	}
	
	@Override
	public String getRespTime() {
		return respTime;
	}
	
	@Override
	public QName getEntityQName() {
		return ENTITY_QNAME;
	}

}
